import bb.cascades 1.0
import bb.system 1.0

Sheet {
    id: aboutSheet
    Page {
        titleBar: TitleBar {
            title: qsTr("About")
            acceptAction: ActionItem {
                title: qsTr("Ok")
                onTriggered: {
                    aboutSheet.close()
                }
            }
        }
        actions: [
            ActionItemOnBarOrSignature {}
        ]
        ScrollView {
            Container {
                topPadding: _ui.du(3)
                leftPadding: topPadding
                rightPadding: topPadding
                bottomPadding: topPadding
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                Container {
                    horizontalAlignment: HorizontalAlignment.Center
                    verticalAlignment: VerticalAlignment.Center
                    Label {
                        id: appNameLabel
                        horizontalAlignment: HorizontalAlignment.Center
                        text: Application.applicationName + " " + Application.applicationVersion
                        textStyle.base: SystemDefaults.TextStyles.BigText
                    }
                    Label {
                        property string emailUri: "mailto:roger@rogerleblanc.net?subject=" + appNameLabel.text + " support"
                        horizontalAlignment: HorizontalAlignment.Center
                        text: "<html><a href=\"" + emailUri + "\">" + qsTr("by CellNinja") + "</a></html>"
                        multiline: true
                        textStyle.base: SystemDefaults.TextStyles.SubtitleText
                    }
                    Container {
                        topPadding: _ui.du(3)
                        horizontalAlignment: HorizontalAlignment.Center
                        Button {
                            imageSource: "asset:///images/ic_share.png"
                            text: "More Apps From CellNinja"
                            onClicked: {
                                invoke.query.uri = "appworld://vendor/70290"
                                invoke.query.updateQuery()
                                invoke.trigger("bb.action.OPEN");
                            }
                        }
                    }
                }
            }
        }
    }
}
