import bb.cascades 1.2

Container {
    property alias question: questionLabel.text
    property alias answer1: answerLabel1.text
    property alias imageSource1: image1.imageSource
    property bool answer1Visible: true
    property alias answer2: answerLabel2.text
    property alias imageSource2: image2.imageSource
    property bool answer2Visible: true
    property alias answer3: answerLabel3.text
    property alias imageSource3: image3.imageSource
    property bool answer3Visible: true
    property alias answer4: answerLabel4.text
    property alias imageSource4: image4.imageSource
    property bool answer4Visible: true
    property alias answer5: answerLabel5.text
    property alias imageSource5: image5.imageSource
    property bool answer5Visible: true
    property alias answer6: answerLabel6.text
    property alias imageSource6: image6.imageSource
    property bool answer6Visible: true

    property variant scalingMethodForAllImages: ScalingMethod.AspectFit

    
    horizontalAlignment: HorizontalAlignment.Fill
    verticalAlignment: VerticalAlignment.Fill
    bottomPadding: _ui.du(3)
    Container {
        id: question
        horizontalAlignment: HorizontalAlignment.Center
        onTouch: {
            if (event.touchType == TouchType.Up) {
                console.log("Touched!")
                answer.visible = !answer.visible
                console.log("answer.visible : " + answer.visible)
            }
        }
        Label {
            id: questionLabel
            horizontalAlignment: HorizontalAlignment.Center
            textStyle.color: touchKeyboard.coloredLabelColor
            multiline: true
        }
    }
    Container {
        id: answer
        visible: false
        horizontalAlignment: HorizontalAlignment.Fill
        verticalAlignment: VerticalAlignment.Fill
        Label {
            id: answerLabel1
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer1Visible
        }
        ImageView {
            id: image1
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer1Visible
        }
        Label {
            id: answerLabel2
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer2Visible
        }
        ImageView {
            id: image2
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer2Visible
        }
        Label {
            id: answerLabel3
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer3Visible
        }
        ImageView {
            id: image3
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer3Visible
        }
        Label {
            id: answerLabel4
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer4Visible
        }
        ImageView {
            id: image4
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer4Visible
        }
        Label {
            id: answerLabel5
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer5Visible
        }
        ImageView {
            id: image5
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer5Visible
        }
        Label {
            id: answerLabel6
            multiline: true
            horizontalAlignment: HorizontalAlignment.Center
            visible: answer6Visible
        }
        ImageView {
            id: image6
            horizontalAlignment: HorizontalAlignment.Center
            maxHeight: _ui.du(60)
            maxWidth: maxHeight
            scalingMethod: scalingMethodForAllImages
            visible: answer6Visible
        }
    }
    Divider {}
}
