import bb.cascades 1.0
import bb.system 1.0

Sheet {
    id: aboutSheet
    Page {
        titleBar: TitleBar {
            title: qsTr("Help")
            acceptAction: ActionItem {
                title: qsTr("Ok")
                onTriggered: {
                    helpSheet.close()
                }
            }
        }
        actions: [
//            ActionItemOnBarOrSignature {}
            TutorialAction {}
        ]
        ScrollView {
            Container {
                topPadding: _ui.du(3)
                leftPadding: topPadding
                rightPadding: topPadding
                bottomPadding: topPadding
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill
                Container {
                    horizontalAlignment: HorizontalAlignment.Fill
                    verticalAlignment: VerticalAlignment.Fill
                    HelpQuestionAnswerContainer {
                        question: qsTr("How to type silently in BBM?")
                        answer1: qsTr("1- In your conversation, long-press on any previous post on the screen and then tap Share icon.")
                        imageSource1: "asset:///images/help/invokeCard/invokeCard1.png"
                        answer2: qsTr("2- Then choose 'Silent Keys' in the list.")
                        imageSource2: "asset:///images/help/invokeCard/invokeCard2.png"
                        answer3: qsTr("3- Type in silence. Select 'Copy Text' once done.")
                        imageSource3: "asset:///images/help/invokeCard/invokeCard3.png"                    
                        answer4: qsTr("4- Long press in the text field and select Paste icon.")
                        imageSource4: "asset:///images/help/invokeCard/invokeCard4.png"                    
                        answer5: qsTr("5- Done!")
                        imageSource5: "asset:///images/help/invokeCard/invokeCard5.png"                    
                    }
                    HelpQuestionAnswerContainer {
                        question: qsTr("How to delete last word?")
                        answer1: qsTr("Swipe left on the touchscreen keyboard.")
                        answer2Visible: false
                        answer3Visible: false
                        answer4Visible: false
                        answer5Visible: false
                        answer6Visible: false
                    }
                    HelpQuestionAnswerContainer {
                        question: qsTr("How can I use the keyboard with one hand?")
                        answer1: qsTr("1- In the app, go to Settings. You'll see 'Left Padding' and 'Right Padding' sliders. You can move them to add a padding on either left or right side of the keyboard.")
                        imageSource1: "asset:///images/help/padding/padding1.png"
                        answer2: qsTr("This will squeeze the keyboard on one side, so it'll be easier to type with one hand.")
                        imageSource2: "asset:///images/help/padding/padding2.png"                    
                        answer3Visible: false
                        answer4Visible: false
                        answer5Visible: false
                        answer6Visible: false
                    }
                    HelpQuestionAnswerContainer {
                        question: qsTr("How can I switch languages?")
                        answer1: qsTr("1- In the app, go to Settings. You can check/uncheck all the keyboard layout (languages) you want to be available.")
                        imageSource1: "asset:///images/help/languages/languages1.png"
                        answer2: qsTr("Then, in the main app, you can switch keyboard by pressing the world ( 🌐 ) button.")
                        imageSource2: "asset:///images/help/languages/languages2.png"
                        answer3Visible: false
                        answer4Visible: false
                        answer5Visible: false
                        answer6Visible: false
                    }
                    HelpQuestionAnswerContainer {
                        question: qsTr("I've made a typo, how can I edit a word in the middle of the text?")
                        answer1: qsTr("To add text, it works exactly the same as you are used to.")
                        answer2: qsTr("To delete text, there's a limitation where this app can't be notified of text selection, so if you select text and hit backspace on the touchscreen keyboard, it will only delete one character. To delete all the selection, use the cisor icon (cut) instead.")
                        imageSource2: "asset:///images/help/deleteWord/cisorIcon.png"
                        answer3Visible: false
                        answer4Visible: false
                        answer5Visible: false
                        answer6Visible: false
                    }
                    HelpQuestionAnswerContainer {
                        property string emailUri: "mailto:roger@rogerleblanc.net?subject=" + Application.applicationName + " " + Application.applicationVersion + " support"
                        question: qsTr("I have another issue with the app, should I leave a negative feedback in BlackBerry World?")
                        answer1: qsTr("Of course not! Contact me first, I'll always try to help users facing problems with this app.")
                        answer2: qsTr("<html><a href=\"" + emailUri + "\">" + qsTr("Click here to email CellNinja") + "</a></html>")
                        answer3Visible: false
                        answer4Visible: false
                        answer5Visible: false
                        answer6Visible: false
                    }
//                    RerunTutorial { topPadding: _ui.du(1); bottomPadding: topPadding; horizontalAlignment: HorizontalAlignment.Center }
                }
            }
        }
    }
}
