import bb.cascades 1.2
import Roger.CustomTimer 1.0

Container {
    layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
    horizontalAlignment: HorizontalAlignment.Center
    Container {
        layoutProperties: StackLayoutProperties { spaceQuota: 4 }
        Label {
            text: "Left Padding : " + sliderLeft.immediateValue.toFixed(0)
            horizontalAlignment: HorizontalAlignment.Center
        }
        Slider {
            id: sliderLeft
            fromValue: 0 - Number(Number((mainPage.deviceWidth / 14.4)).toFixed(0))
            toValue: (mainPage.deviceWidth / 3)
            value: touchKeyboard.leftPadding
            onValueChanged: { 
                console.log("sliderLeft value: " + value)
                _settings.setValue("paddingOnLeftSide", Number(value.toFixed(0)))
                touchKeyboard.leftPadding = value
                resetKeyboard(touchKeyboard.keyboardLanguage)
            }
        }
    }

    Container {
        layoutProperties: StackLayoutProperties { spaceQuota: 1 }
    }
    
    Container {
        layoutProperties: StackLayoutProperties { spaceQuota: 4 }
        Label {
            text: "Right Padding : " + sliderRight.immediateValue.toFixed(0)
            horizontalAlignment: HorizontalAlignment.Center
        }
        Slider {
            id: sliderRight
            fromValue: 0 - Number(Number((mainPage.deviceWidth / 14.4)).toFixed(0))
            toValue: (mainPage.deviceWidth / 3)
            rotationZ: 180
//            value: Number(_settings.value("paddingOnRightSide", 0))
            value: touchKeyboard.rightPadding
            onValueChanged: { 
                _settings.setValue("paddingOnRightSide", Number(value.toFixed(0)))
                touchKeyboard.rightPadding = Number(value.toFixed(0))
                resetKeyboard(touchKeyboard.keyboardLanguage)
            }
        }
    }
    
    function resetKeyboard(layout) {
        if (layout == "Reset")
            return
        
        console.log("resetKeyboard: " + layout)
        touchKeyboard.keyboardIsResetting = true 
        touchKeyboard.keyboardLanguage = "Reset"
        delayResetKeyboard.layout = layout
        delayResetKeyboard.start()
    }
    
    attachedObjects: [
        Timer {
            property string layout
            id: delayResetKeyboard
            interval: 100
            singleShot: true
            onTimeout: {
                console.log("delayResetKeyboard: " + layout)
                touchKeyboard.keyboardLanguage = layout
                touchKeyboard.keyboardIsResetting = false
            }
        }
    ]
}
