import bb.cascades 1.2
import bb.system 1.2

Sheet {
    id: settingsSheet
    
    Page {
        titleBar: TitleBar {
            title: qsTr("Settings")
            acceptAction: ActionItem {
                title: qsTr("Ok")
                onTriggered: {
                    settingsSheet.close()
                }
            }
        }
        actions: [
//            ActionItemOnBarOrSignature {}
            TutorialAction {}
        ]
        ScrollView {
            Container {
                id: mainContainer
                layout: DockLayout {}
                horizontalAlignment: HorizontalAlignment.Fill
                verticalAlignment: VerticalAlignment.Fill

                property double numberOfDoubleTaps: 0

                gestureHandlers: [
                    DoubleTapHandler {
                        onDoubleTapped: {
                            mainContainer.numberOfDoubleTaps++
                            if (mainContainer.numberOfDoubleTaps == 2) {
                                mainContainer.numberOfDoubleTaps = 0
                                _settings.setValue("sendToConsoleDebug", !_settings.value("sendToConsoleDebug", false))
                                systemToast.body = "ConsoleDebug mode set to " + (_settings.value("sendToConsoleDebug", false) ? "ON" : "OFF")
                                systemToast.show()
                            }
                        }
                        attachedObjects: [
                            SystemToast {
                                id: systemToast
                            }
                        ]
                    }
                ]

                Container {
                    leftPadding: _ui.du(3)
                    rightPadding: leftPadding
                    bottomPadding: leftPadding
                    
                    Header { title: "Support this app" }
                    DonateContainer {}
                    Header { title: qsTr("Text Entry Visual") }
                    TextAreaSizeContainer { topPadding: _ui.du(1) }
                    Header { title: qsTr("Keyboard Visual And Layout") }
                    KeyButtonSelectorContainer { topPadding: _ui.du(1) }
                    KeyboardSizeContainer { topPadding: _ui.du(1) }
                    LetterSizeContainer { topPadding: _ui.du(1) }
                    PaddingContainer { topPadding: _ui.du(3) }
                    Header { title: "Keyboard Languages" }
                    LanguageContainer { topPadding: _ui.du(1) }
                    Header { title: "Theme" }
                    ThemeContainer { topPadding: _ui.du(1) } 
                    FontContainer { topPadding: _ui.du(1) }
                    FontTesterTextArea { topPadding: _ui.du(1) }
//                    Header { title: "Tutorial" }
//                    RerunTutorial { topPadding: _ui.du(1); bottomPadding: topPadding }
                }
            }            
        }
    }         
}
