import bb.cascades 1.2
import bb.system 1.2
import Roger.CustomTimer 1.0

Container {
    id: touchKeyboardContainer
    
    property variant extraRow
    
    property variant specialCharactersRow

    property variant firstRowLetters
    property variant secondRowLetters
    property variant thirdRowLetters
    
    property variant firstRowCharacters
    property variant secondRowCharacters
    property variant thirdRowCharacters
    
    property variant firstRowSpecialCharacters
    property variant secondRowSpecialCharacters
    property variant thirdRowSpecialCharacters

    property variant aLongPressLetters: ["À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "ą"]
    property variant cLongPressLetters: ["Ç", "©", "č", "ć", "ċ"]
    property variant dLongPressLetters: ["Ð"]
    property variant eLongPressLetters: ["É", "È", "Ê", "Ë", "ę", "ė"]
    property variant gLongPressLetters: ["ġ"]
    property variant hLongPressLetters: ["ħ"]
    property variant iLongPressLetters: ["Ì", "Í", "Î", "Ï", "į"]
    property variant lLongPressLetters: ["ł"]
    property variant nLongPressLetters: ["Ñ", "ń"]
    property variant oLongPressLetters: ["Ò", "Ó", "Ô", "Õ", "Ö", "Œ", "Ø"]
    property variant pLongPressLetters: ["¶"]
    property variant rLongPressLetters: ["®"]
    property variant sLongPressLetters: ["§", "ß", "š", "ς", "ś"]
    property variant tLongPressLetters: ["þ", "™"]
    property variant uLongPressLetters: ["Ù", "Ú", "Û", "Ü", "ų", "ū"]
    property variant yLongPressLetters: ["Ý", "Ÿ"]
    property variant zLongPressLetters: ["ž", "ż", "ź"]
    property variant special1LongPressLetters: ["?", "¿", "!", "¡", "«", "»", "\"", ",", "."]
    property variant special2LongPressLetters: [":", ";", "<", ">", "{", "}", "[", "]", "~", "|", "/", "\\"]
    property variant special3LongPressLetters: ["`", "°", "^", "¨"]
    property variant special4LongPressLetters: ["!", "@", "#", "$", "%", "?", "&", "*", "(", ")"]
    property variant special5LongPressLetters: ["€", "¥", "£", "+", "-", "="]
    property variant displayedLongPressLetters
    
    property variant listOfKeyboardsSupported: ["Arabic", "Armenian", "AZERTY", "Bulgarian", "Bulgarian_Phonetic", "Dvorak", "EMOTICONS", "Estonian", "Finnish", "Georgian", "German", "Greek", "Hebrew", "Hebrew_(Traditional)", "Italian", "Latvian", "Lithuanian", "Macedonian", "Maltese", "Mongolian", "Nordic", "Persian", "Polish", "QWERTY", "QWERTZ", "QZERTY", "Russian", "Serbian", "Slovenian", "Spanish", "Special_Characters", "Swedish", "Turkish", "Ukrainian", "Ukrainian2", "Urdu", "Urdu2", "Urdu3", "Vietnamese"]
    property variant listOfDefaultKeyboards: ["EMOTICONS", "QWERTY"]
    property variant listOfKeyboardsEnabled: _settings.value("listOfKeyboardsEnabled", listOfDefaultKeyboards)
    property string keyboardLanguage: (_settings.value("keyboardLanguage", "QWERTY") != "Reset") ? _settings.value("keyboardLanguage", "QWERTY") : "QWERTY"
    property bool thisIsFirstKeyboardChange: true
    property bool keyboardIsResetting: true
    
    property bool lastLetterLongPressed: false
    property bool shiftPressedOnce: true
    property bool shiftLongPressed: false    
    property bool a123LongPressed: false

    property double userPreferenceHeight: _settings.value("userPreferenceHeight", 1)
    property double userPreferenceLetterSize: _settings.value("userPreferenceLetterSize", 1)
    property bool deviceIsInPortraitMode: OrientationSupport.orientation == UIOrientation.Portrait
    property int eachKeyHeight: _ui.du(9) * userPreferenceHeight
    property int paddingBetweenRows: _ui.du(1)
    property int keyboardLayout: 0
    
    property string buttonType: _settings.value("buttonType", "Rectangle")
    
    property variant defaultLabelColor: invisibleLabel.textStyle.color
    property variant coloredLabelColor: Color.create("#33CCFF")

    property string fontUsed: _settings.value("fontUsed", "defaultFont")

    onFontUsedChanged: {
        if (fontUsed == "defaultFont") {
            textArea.textStyle.base = defaultFont.style
        }
        else if (fontUsed == "arialFont") {
            textArea.textStyle.base = arialFont.style
        }
        else if (fontUsed == "andaleMonoFont") {
            textArea.textStyle.base = andaleMonoFont.style
        }
        else if (fontUsed == "comicSansMSFont") {
            textArea.textStyle.base = comicSansMSFont.style
        }
        else if (fontUsed == "courierNewFont") {
            textArea.textStyle.base = courierNewFont.style
        }
        else if (fontUsed == "dejaVuSansFont") {
            textArea.textStyle.base = dejaVuSansFont.style
        }
        else if (fontUsed == "dejaVuSansCondensedFont") {
            textArea.textStyle.base = dejaVuSansCondensedFont.style
        }
        else if (fontUsed == "dejaVuSansMonoFont") {
            textArea.textStyle.base = dejaVuSansMonoFont.style
        }
        else if (fontUsed == "dejaVuSerifFont") {
            textArea.textStyle.base = dejaVuSerifFont.style
        }
        else if (fontUsed == "dejaVuSerifCondensedFont") {
            textArea.textStyle.base = dejaVuSerifCondensedFont.style
        }
        else if (fontUsed == "georgiaFont") {
            textArea.textStyle.base = georgiaFont.style
        }
        else if (fontUsed == "impactFont") {
            textArea.textStyle.base = impactFont.style
        }
        else if (fontUsed == "mTExtraFont") {
            textArea.textStyle.base = mTExtraFont.style
        }
        else if (fontUsed == "nastaleeqFont") {
            textArea.textStyle.base = nastaleeqFont.style
        }
        else if (fontUsed == "nastaleeqFont2") {
            textArea.textStyle.base = nastaleeqFont2.style
        }
        else if (fontUsed == "nazaninFont") {
            textArea.textStyle.base = nazaninFont.style
        }
        else if (fontUsed == "tahomaFont") {
            textArea.textStyle.base = tahomaFont.style
        }
        else if (fontUsed == "timesNewRomanFont") {
            textArea.textStyle.base = timesNewRomanFont.style
        }
        else if (fontUsed == "trebuchetMSFont") {
            textArea.textStyle.base = trebuchetMSFont.style
        }
        else if (fontUsed == "verdanaFont") {
            textArea.textStyle.base = verdanaFont.style
        }
    }

    property int startX
    property int stopX
    property int startY
    property int stopY
    property string textBeforeEraseLastWordSwipe
    property bool userIsSwiping: false

    onUserIsSwipingChanged: {
        console.log("userIsSwiping : " + userIsSwiping)
    }    
    
    leftPadding: _settings.value("paddingOnLeftSide", 0)
    rightPadding: _settings.value("paddingOnRightSide", 0)

    onListOfKeyboardsEnabledChanged: { 
        if (listOfKeyboardsEnabled.length <= 0) {
            listOfKeyboardsEnabled = ["QWERTY"]

            systemToast.cancel()
            systemToast.body = "List of languages cannot be empty"
            systemToast.show()
        }
    }

    function showThis(message) {
        // Used to debug
        var date = new Date()
        textArea.text = date.toLocaleTimeString() + " " + message + "\n" + textArea.text
    }
    
    function reloadRow(container, row) {
        // Abort if deviceWidth is not set yet
        if ((mainPage.deviceWidth <= 0) || (mainPage.deviceHeight <= 0))
            return 
            
        var numberOfKeySpace = row.length + ((row.lastIndexOf(" ") >= 0) ? 1 : 0)        
        var thisKeyWidth = Math.floor((((deviceIsInPortraitMode ? mainPage.deviceWidth : mainPage.deviceHeight) - leftPadding - rightPadding) / numberOfKeySpace))
        if (row.length != container.count()) {
            // RELOAD!!!
            container.removeAll()
            for (var i = 0; i < row.length; i++) {
                var thisKey = emptyKey.createObject()
                thisKey.letter = row[i]
                thisKey.keyWidth = (row[i] == " ") ? (thisKeyWidth * 2) : thisKeyWidth
                container.add(thisKey)
            }
        }
        else {
            // USE SAME KEYS
            for (var i = 0; i < container.count(); i++) {
                var thisKey = container.at(i)
                thisKey.letter = row[i]
                thisKey.keyWidth = (row[i] == " ") ? (thisKeyWidth * 2) : thisKeyWidth
            }
        }
    }

    onExtraRowChanged: { reloadRow(extraRowContainer, extraRow) }
    
    onDisplayedLongPressLettersChanged: { reloadRow(displayedLongPressLettersContainer, displayedLongPressLetters) }
    
    onSpecialCharactersRowChanged: { reloadRow(specialCharactersRowContainer, specialCharactersRow) }
    
    onFirstRowLettersChanged: { reloadRow(firstRowLettersContainer, firstRowLetters) }
    onSecondRowLettersChanged: { reloadRow(secondRowLettersContainer, secondRowLetters) }
    onThirdRowLettersChanged: { reloadRow(thirdRowLettersContainer, thirdRowLetters) }
    
    onFirstRowCharactersChanged: { reloadRow(firstRowCharactersContainer, firstRowCharacters) }
    onSecondRowCharactersChanged: { reloadRow(secondRowCharactersContainer, secondRowCharacters) }
    onThirdRowCharactersChanged: { reloadRow(thirdRowCharactersContainer, thirdRowCharacters) }
    
    onFirstRowSpecialCharactersChanged: { reloadRow(firstRowSpecialCharactersContainer, firstRowSpecialCharacters) }
    onSecondRowSpecialCharactersChanged: { reloadRow(secondRowSpecialCharactersContainer, secondRowSpecialCharacters) }
    onThirdRowSpecialCharactersChanged: { reloadRow(thirdRowSpecialCharactersContainer, thirdRowSpecialCharacters) }
    
    onKeyboardLanguageChanged: {
        console.log("onKeyboardLanguageChanged : " + keyboardLanguage)

        if (!keyboardIsResetting) {
            _settings.setValue("keyboardLanguage", keyboardLanguage)
        
            var language = new String()
            language = keyboardLanguage
            language = language.replace("_", " ")
            if (language == "Armenian")
                language += " (10.3 and up)"
            
            if (!touchKeyboardContainer.thisIsFirstKeyboardChange) {
                systemToast.cancel()
                systemToast.body = language
                systemToast.show()
                touchKeyboardContainer.thisIsFirstKeyboardChange = false
            }
            else
                touchKeyboardContainer.thisIsFirstKeyboardChange = false
        }
        
        if (keyboardLanguage == "") {
            keyboardLanguage = "QWERTY"
            _settings.setValue("keyboardLanguage", keyboardLanguage)
            return
        }            
        
        selectedLanguage.source = "asset:///keyboardsLayout/" + keyboardLanguage + "_Keyboard.qml"
        var thisKeyboard = selectedLanguage.createObject()
        
        extraRow = thisKeyboard.extraRow
        if (extraRow.length > 0)
            extraRowContainer.visible = true
        else 
            extraRowContainer.visible = false
        
        firstRowLetters = thisKeyboard.firstRowLetters
        secondRowLetters = thisKeyboard.secondRowLetters
        thirdRowLetters = thisKeyboard.thirdRowLetters
        
        firstRowCharacters = thisKeyboard.firstRowCharacters
        secondRowCharacters = thisKeyboard.secondRowCharacters
        thirdRowCharacters = thisKeyboard.thirdRowCharacters
        
        firstRowSpecialCharacters = thisKeyboard.firstRowSpecialCharacters
        secondRowSpecialCharacters = thisKeyboard.secondRowSpecialCharacters
        thirdRowSpecialCharacters = thisKeyboard.thirdRowSpecialCharacters
        
        delaySpecialCharactersRowChange.specialCharactersRow = thisKeyboard.specialCharactersRow
        delaySpecialCharactersRowChange.start()
    }        
    
    onLastLetterLongPressedChanged: {
        if (!lastLetterLongPressed && shiftLongPressed)
            shiftLongPressed = false
    }
    
    function handleLongPressed(letterLongPressed) {
        if (letterLongPressed == "↑") {
            shiftLongPressed = !shiftLongPressed
            return 
        }
        
        if (letterLongPressed == "@123") {
            touchKeyboardContainer.a123LongPressed = true
            
            touchKeyboardContainer.keyboardLayout += 1
            if (touchKeyboardContainer.keyboardLayout > 2)
                touchKeyboardContainer.keyboardLayout = 0
                
            return
        }
        
        lastLetterLongPressed = true;
        console.log(letterLongPressed.toString().toLowerCase() + " long pressed");
        var lettersThatCanBeLongPressed = ["a", "c", "d", "e", "g", "h", "i", "l", "n", "o", "p", "r", "s", "t", "u", "y", "z", "ו", "י", "ח", "?", "!", "'", "-", ":", ";", "@", ",", ".", "$", "€"]
        if (letterLongPressed == "↑")
            shiftLongPressed = true
        else if (lettersThatCanBeLongPressed.lastIndexOf(letterLongPressed.toString().toLowerCase()) >= 0) {
            if (letterLongPressed.toString().toLowerCase() == "a")
                displayedLongPressLetters = aLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "c")
                displayedLongPressLetters = cLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "d")
                displayedLongPressLetters = dLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "e")
                displayedLongPressLetters = eLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "g")
                displayedLongPressLetters = gLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "h")
                displayedLongPressLetters = hLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "i")
                displayedLongPressLetters = iLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "n")
                displayedLongPressLetters = nLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "o")
                displayedLongPressLetters = oLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "p")
                displayedLongPressLetters = pLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "r")
                displayedLongPressLetters = rLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "s")
                displayedLongPressLetters = sLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "t")
                displayedLongPressLetters = tLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "u")
                displayedLongPressLetters = uLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "y")
                displayedLongPressLetters = yLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "z")
                displayedLongPressLetters = zLongPressLetters
            else if (letterLongPressed.toString().toLowerCase() == "l")
                displayedLongPressLetters = lLongPressLetters
            else if (letterLongPressed == "ו")
                displayedLongPressLetters = ["װ"]
            else if (letterLongPressed == "י")
                displayedLongPressLetters = ["ײ"]
            else if (letterLongPressed == "ח")
                displayedLongPressLetters = ["ױ"]
            else if (letterLongPressed == "?")
                displayedLongPressLetters = special1LongPressLetters
            else if (letterLongPressed == "!")
                displayedLongPressLetters = special1LongPressLetters
            else if (letterLongPressed == ",")
                displayedLongPressLetters = special1LongPressLetters
            else if (letterLongPressed == ".")
                displayedLongPressLetters = special1LongPressLetters
            else if (letterLongPressed == ":")
                displayedLongPressLetters = special2LongPressLetters
            else if (letterLongPressed == ";")
                displayedLongPressLetters = special2LongPressLetters
            else if (letterLongPressed == "'")
                displayedLongPressLetters = special3LongPressLetters
            else if (letterLongPressed == "@")
                displayedLongPressLetters = special4LongPressLetters
            else if (letterLongPressed == "-")
                displayedLongPressLetters = special5LongPressLetters
            else if (letterLongPressed == "$")
                displayedLongPressLetters = special5LongPressLetters
            else if (letterLongPressed == "€")
                displayedLongPressLetters = special5LongPressLetters
                            
            displayedLongPressLettersContainer.visible = true
        }
    }
    
    function analyzeSwipe(event) {
        var horizontalMinimalSwipeInDU = 20
        var verticalMinimalSwipeInDU = 6 * userPreferenceHeight
        
        switch (event.touchType) {
            case TouchType.Down: {
                startX = event.windowX
                startY = event.windowY
                break
            }
            case TouchType.Move: {
                if (!userIsSwiping) {
                    var distanceX = (event.windowX - startX) / _ui.du(1)
                    var distanceY = (event.windowY - startY) / _ui.du(1)
                        
                    if ((distanceX > (horizontalMinimalSwipeInDU / 2)) || (distanceY > (verticalMinimalSwipeInDU / 2)) || (distanceX < (0 - (horizontalMinimalSwipeInDU / 2))) || (distanceY < (0 - (verticalMinimalSwipeInDU / 2)))) 
                        userIsSwiping = true
                }
                break
            }
            case TouchType.Up: {
                stopX = event.windowX
                stopY = event.windowY
                    
                var distanceX = (stopX - startX) / _ui.du(1)
                var distanceY = (stopY - startY) / _ui.du(1)
                    
                if (distanceX > horizontalMinimalSwipeInDU) {
                    //console.log("Swiped right " + distanceX)
                    swipeRight(distanceX)
                } else {
                    if (distanceX < (0 - horizontalMinimalSwipeInDU)) {
                        //console.log("Swiped left " + distanceX)
                        swipeLeft(distanceX)
                    } 
                }
                    
                if (distanceY > verticalMinimalSwipeInDU) {
                    //console.log("Swiped down " + distanceY)
                    swipeDown(distanceY)
                } else {
                    if (distanceY < (0 - verticalMinimalSwipeInDU)) {
                        //console.log("Swiped up " + distanceY)
                    } 
                }
                    
                break
            }
        }
        
        
        if (event.touchType == TouchType.Up) {
        }
    }

    function swipeLeft(distance) {
        textBeforeEraseLastWordSwipe = textArea.text
        
        while (textArea.text.charAt(textArea.text.length - 1) == " ")
            textArea.text = textArea.text.substring(0, textArea.text.length - 1)
            
        if (textArea.text.lastIndexOf(" ") <= 0)
            textArea.text = ""
        else {
            var lastSpacePosition = textArea.text.lastIndexOf(" ")
            var lastReturnPosition = textArea.text.lastIndexOf("\n")
            var endOfTextNotDeleted
            if (lastSpacePosition > lastReturnPosition)
                endOfTextNotDeleted = lastSpacePosition + 1
            else 
                endOfTextNotDeleted = lastReturnPosition
            textArea.text = textArea.text.substring(0, endOfTextNotDeleted)
        }
            
        deleteWordSystemToast.cancel()
        deleteWordSystemToast.body = "Deleted last word"
        deleteWordSystemToast.show()
        
        timer.start()
    }

    function swipeRight(distance) {
        keyboardLayout += 1
        if (keyboardLayout > 3)
            keyboardLayout = 0
    }

    function swipeDown(distance) {
    }

    attachedObjects: [
        ComponentDefinition { id: selectedLanguage },
        ComponentDefinition { id: emptyKey; source: "EmptyKey.qml" },
        SystemToast { id: systemToast },
        SystemToast {
            id: deleteWordSystemToast
            button.label: "Undo"
            button.enabled: true            
            onFinished: {
                if (buttonSelection().label == "Undo")
                    textArea.text = textBeforeEraseLastWordSwipe
            }
        },
        Timer {
            id: timer
            interval: 2000
            onTimeout: { deleteWordSystemToast.cancel(); timer.stop() }
        },
        Timer {
            id: delaySpecialCharactersRowChange
            
            property variant specialCharactersRow

            interval: 50
            onTimeout: { 
                touchKeyboardContainer.specialCharactersRow = delaySpecialCharactersRowChange.specialCharactersRow
                delaySpecialCharactersRowChange.stop()
            }
        },
        TextStyleDefinition {
            id: defaultFont
            fontFamily: "Slate Pro"
        },
        TextStyleDefinition {
            id: arialFont
            fontFamily: "Arial"
        },
        TextStyleDefinition {
            id: andaleMonoFont
            fontFamily: "Andale Mono"
        },
        TextStyleDefinition {
            id: comicSansMSFont
            fontFamily: "Comic Sans MS"
        },
        TextStyleDefinition {
            id: courierNewFont
            fontFamily: "Courier New"
        },
        TextStyleDefinition {
            id: dejaVuSansFont
            fontFamily: "DejaVu Sans"
        },
        TextStyleDefinition {
            id: dejaVuSansCondensedFont
            fontFamily: "DejaVu Sans Condensed"
        },
        TextStyleDefinition {
            id: dejaVuSansMonoFont
            fontFamily: "DejaVu Sans Mono"
        },
        TextStyleDefinition {
            id: dejaVuSerifFont
            fontFamily: "DejaVu Serif"
        },
        TextStyleDefinition {
            id: dejaVuSerifCondensedFont
            fontFamily: "DejaVu Serif Condensed"
        },
        TextStyleDefinition {
            id: georgiaFont
            fontFamily: "Georgia"
        },
        TextStyleDefinition {
            id: impactFont
            fontFamily: "Impact"
        },
        TextStyleDefinition {
            id: mTExtraFont
            fontFamily: "MT Extra"
        },
        TextStyleDefinition {
            id: nastaleeqFont
            rules: [
                FontFaceRule {
                    source: "asset:///Fonts/Nastaleeq.ttf"
                    fontFamily: "Nastaleeq"
                }
            ]
            fontFamily: "Nastaleeq, sans-serif"
        },
        TextStyleDefinition {
            id: nazaninFont
            rules: [
                FontFaceRule {
                    source: "asset:///Fonts/Nazanin.ttf"
                    fontFamily: "Nazanin"
                }
            ]
            fontFamily: "Nazanin, sans-serif"
        },
        TextStyleDefinition {
            id: tahomaFont
            fontFamily: "Tahoma"
        },
        TextStyleDefinition {
            id: timesNewRomanFont
            fontFamily: "Times New Roman"
        },
        TextStyleDefinition {
            id: trebuchetMSFont
            fontFamily: "Trebuchet MS"
        },
        TextStyleDefinition {
            id: verdanaFont
            fontFamily: "Verdana"
        }
    ]
    
    Label {
        // Used to get the default text color in EmptyKey.qml
        id: invisibleLabel
        visible: false
    }

    Container {
        id: displayedLongPressLettersContainer
        visible: false
        layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
        bottomPadding: paddingBetweenRows
    }
    
    Container {
        id: extraRowContainer
        visible: false
        layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
        bottomPadding: paddingBetweenRows
    }
    
    Container {
        id: specialCharactersRowContainer
        layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
        horizontalAlignment: HorizontalAlignment.Center
        verticalAlignment: VerticalAlignment.Center
        bottomPadding: paddingBetweenRows
    }
    
    Container {
        id: lettersKeyboard
        visible: keyboardLayout == 0
        onTouch: analyzeSwipe(event)
        Container {
            id: firstRowLettersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: secondRowLettersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: thirdRowLettersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        }
    }

    Container {
        id: charactersKeyboard
        visible: keyboardLayout == 1
        onTouch: analyzeSwipe(event)
        Container {
            id: firstRowCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: secondRowCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: thirdRowCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        }
    }

    Container {
        id: specialCharactersKeyboard
        visible: keyboardLayout == 2
        onTouch: analyzeSwipe(event)
        Container {
            id: firstRowSpecialCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: secondRowSpecialCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            bottomPadding: paddingBetweenRows
        }
        
        Container {
            id: thirdRowSpecialCharactersContainer
            layout: StackLayout { orientation: LayoutOrientation.LeftToRight }
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
        }
    }
}
